#!/bin/sh
FS=ext4
MNTDIR=/mmc
TESTDIR=$MNTDIR/test
TESTDIR2ND=$MNTDIR/test2nd
TESTDIR3RD=$MNTDIR/test3rd
STATIC=$MNTDIR/static
TESTCTRL=/testctrl
DEV=/dev/mmcblk1p2
LOG=/emmc-$FS-log
COUNT=$LOG/count
echo =======================================$LOG
LIVE=$LOG/live
FSCK=/root/e2fs_bin/sbin/fsck.ext4
WRITER=/usr/bin/stability-1031.out
OPT1RO=journal_checksum,data=ordered,relatime,barrier=1,ro
OPT1RW=journal_checksum,data=ordered,relatime,barrier=1,rw

OPT2=noatime,journal_ioprio=1,data=ordered,discard
OPT5=data=ordered,relatime,journal_checksum,discard,barrier=1,ro
#OPTRW=data=ordered,relatime,journal_checksum,discard,barrier=1,rw
OPT6=data=ordered,relatime,discard
OPT4=data=journal,relatime,journal_checksum
PORT=6000
#OPTRW=data=ordered,relatime,journal_checksum,discard,barrier=1,rw


search_invalid()
{
/bin/cat $1 | /bin/grep "has an invalid extent" -rw
return $?
}

search_bad_inode()
{
/bin/cat $1 | /bin/grep "^Inode [0-9]*, i_blocks is [0-9]*, should be" -rw
return $?
}


/bin/echo "================test wait============" > /dev/console
sleep 5
/bin/echo 200 > /proc/sys/vm/dirty_writeback_centisecs
/bin/cat /proc/sys/vm/dirty_writeback_centisecs
/bin/echo 1 > /proc/sys/vm/dirty_ratio
/bin/echo 65536 > /proc/sys/vm/min_free_kbytes
/bin/cat /proc/sys/vm/min_free_kbytes
#mount -o ro,remount /
if ! [ -d /x ]
then
/bin/echo "==exit=="
exit
fi

/bin/echo "================TEST COUNT=$COUNT============" > /dev/console
if ! [ -d $LOG ]
then
/bin/mkdir $LOG
sync
fi

if ! [ -f $LIVE ]
then
/bin/echo "===== create live file"
/bin/echo 0 > $LIVE
fi

if [ -f /nfs/time.txt ]
then
/scripts/t.sh /nfs/time.txt
time=`cat /nfs/time.txt`
date $time
date
#echo 0 > $LIVE
fi


if ! [ -f $COUNT ]
then
/bin/echo "===== create COUNT file"
/bin/echo 0 > $COUNT
fi

testmutli=1

/bin/echo "======================================= START TEST " > /dev/console
if ! [ -d $MNTDIR ]
then
/bin/mkdir -p $MNTDIR
/bin/echo "======================================= create mount dir " > /dev/console
fi

#
# before mount the device, do fsck to check whether there is bad inode
#
$FSCK -n $DEV > $LOG/fsck.log
sync
search_invalid $LOG/fsck.log
ret=$?
if [ $ret -eq 0 ]
then
echo "======================================= found invalid" > /dev/console
/bin/rm -rf /x
/bin/sync
exit
else
echo "======================================= don't found invalid" > /dev/console
fi

search_bad_inode $LOG/fsck.log
ret=$?
if [ $ret -eq 0 ]
then
echo "======================================= found bad inode" > /dev/console
/bin/rm -rf /x
/bin/sync
exit
else
echo "======================================= don't found  bad inode" > /dev/console
fi


/bin/echo "======================================= BACKUP JOURNAL BLOCKS" > /dev/console
/bin/dd if=/dev/mmcblk1p2 of=$LOG/journal.img bs=4096 skip=557056 count=32768
/bin/sync
#
#mount the test device
#mount -t $FS -o $OPT1RO  $DEV $MNTDIR
MRET=$?
mount | grep $DEV

if [ $MRET -ne "0" ]
then
echo "======================================= MOUNT TEST PARTITION $DEV ERROR"
rm -rf /x
sync
exit
fi

#
#start file checksum checking in 1st dir
if [ -d $TESTDIR ]
then

echo "======================================= CHECKSUM checking .... $TESTDIR"  > /dev/console

$WRITER  -d $TESTDIR -a ro > /dev/console
RET=$?
/bin/echo "======================================= $RET"  > /dev/console
if [ $RET -gt "0" ]
then
/bin/echo "======================================= CHECKSUM ERROR!!!!" > /dev/console

/bin/rm -rf /x
/bin/sync

exit
fi

fi
#========
#
#reset remote PC wdt
/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN"  > /dev/console

#
#start file checksum checking in 2nd dir
if [ -d $TESTDIR2ND ]
then

echo "======================================= CHECKSUM checking .... $TESTDIR2ND"  > /dev/console

$WRITER  -d $TESTDIR2ND -a ro > /dev/console
RET=$?
/bin/echo "======================================= $RET"  > /dev/console
if [ $RET -gt "0" ]
then
/bin/echo "======================================= CHECKSUM ERROR!!!!" > /dev/console

/bin/rm -rf /x
/bin/sync

exit

fi

fi

/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN"  > /dev/console
#
#start file checksum checking in 3rd dir
if [ -d $TESTDIR3RD ]
then

echo "======================================= CHECKSUM checking .... $TESTDIR3RD"  > /dev/console

#$WRITER  -d $TESTDIR3RD -a ro > /dev/console
RET=0
/bin/echo "======================================= $RET"  > /dev/console
if [ $RET -gt "0" ]
then
/bin/echo "======================================= CHECKSUM ERROR!!!!" > /dev/console

/bin/rm -rf /x
/bin/sync

exit

fi

fi
#
#remount and delete files
#mount -o remount,$OPT1RW $MNTDIR
/bin/rm -rf $TESTDIR  $TESTDIR2ND $TESTDIR3RD
/bin/mkdir $TESTDIR $TESTDIR2ND $TESTDIR3RD -p

/bin/dmesg -k > $LOG/dmesg.txt
/bin/sync
/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN"  > /dev/console
/bin/echo "ClEaN" > /dev/console
/bin/echo "ClEaN" > /dev/console
/bin/echo "ClEaN" > /dev/console
/bin/echo "ClEaN" > /dev/console
/bin/echo "ClEaN" > /dev/console
/bin/echo "ClEaN" > /dev/console


#
#update loop counter
count=`cat $COUNT`
count=`expr $count + 1`
/bin/echo $count > $COUNT
/bin/echo "======================================= LOOP $count" > /dev/console
/bin/sync
/bin/echo "========================================STRESS RUN!!" > /dev/console
/home/root/stress -c 15 --vm 8 --vm-bytes 500K &
$WRITER  -d $STATIC  -a ro -m 1 &
sleep 0.5
/usr/bin/emergency_restart.out -t 45


/bin/echo "======================================= WRITING FILES TO $TESTDIR"  > /dev/console
$WRITER  -d $TESTDIR  -a ws  -t 40960 -p 1 -c 10 -b 1 -i $count -e 1 > /dev/console &

testmutli=1
if [ $testmutli -eq "1" ]
then
/bin/echo "======================================= WRITING FILES TO $TESTDIR2ND"  > /dev/console
$WRITER  -d $TESTDIR2ND  -a ws  -t 40960 -p 2 -c 10 -b 1 -i $count -e 1 > /dev/console
#/bin/echo "======================================= WRITING FILES TO $TESTDIR3RD"  > /dev/console
#$WRITER  -d $TESTDIR3RD  -a ws  -t 40960 -p 2 -c 10 -b 1 -i $count -e 1 > /dev/console
fi

/bin/ps | /bin/grep stab
/bin/echo "======================================= TEST SCRIPT END"  > /dev/console
#date
